
KLIC1    EQU       0f6eh                    ; kl 1 (AX)
KLIC2    EQU       0a6e3h                   ; kl 2 (BX)
KLIC3    EQU       5e4dh                    ; kl 3 (CX)
KLIC4    EQU       33eah                    ; kl 4 (CX vstup)

; *****************************************************************************
;
;                                 EGACS
;              Instalace eskch znak na displej EGA/VGA
;
; *****************************************************************************

KORIG    EQU       5ch-103h                 ; korekce adresy

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Instal                   ; instalace programu

ZacRez   label     near                     ; zatek rezidentn sti

Old10    dd        0                        ; pvodn adresa obsluhy INT 10h

FontTab  db        1                        ; slo tabulky font
                                            ;   0=bez font
                                            ;   1=Kamenickch
                                            ;   2=Latin 2
                                            ;   3=KOI 8
                                            ;   4=ISO 8859/2
                                            ;   5=WINDOWS (ISO 8859)
                                            ;   6=minimalizovan Latin 2

RegMap   db        0                        ; nastaven registru pro mapovn

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 10h
; -----------------------------------------------------------------------------

Int10    PROC      FAR

; ------ test instalace programu

         pushf
         cmp       ax,KLIC1
         jne       Int101
         cmp       bx,KLIC2
         jne       Int101
         cmp       cx,KLIC3
         jne       Int101
         call      dword ptr cs:[Old10+KORIG] ; voln pvodn funkce
         push      cs
         pop       es
         mov       cx,KLIC4                 ; vstupn identifiktor
         iret

; ------ kontrola, zda je funkce zapnuta

Int101:  cmp       byte ptr cs:[FontTab+KORIG],0 ; je njak font ?
         je        Int102                   ; funkce je vypnuta

; ------ rozlien, zda se maj peinstalovat fonty

         or        ah,ah                    ; je nastaven mdu displeje ?
         jz        Int103                   ; je nastaven videomdu
         cmp       ax,4f02h                 ; je nastaven mdu VESA ?
         je        Int103                   ; je nastaven mdu VESA
         cmp       ah,11h                   ; je sluba obsluhy font ?
         jne       Int102                   ; nen operace s fonty

; ------ kontrola, zda je nastaven font sluby 11h

         test      al,0fh                   ; jsou uiv. fonty nebo informace ?
         jz        Int102                   ; uivatelsk fonty nebo informace
         cmp       al,3                     ; je nastaven bloku font ?
         jne       Int103                   ; nen nastaven bloku
Int102:  popf
         jmp       dword ptr cs:[Old10+KORIG]; skok na pvodn obsluhu INT 10h

; ------ fonty se peinstaluj

Int103:  call      dword ptr cs:[Old10+KORIG] ; voln pvodn funkce

; ------ schova registr

Int1032: push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      ds
         push      es

; ------ kontrola, zda je standardn textov videomd

         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0 datov segment BIOS
         mov       al,ds:[449h]             ; aktuln videomd
         and       al,7fh                   ; zruen pznaku nemazn displeje
         mov       ah,0eh                   ; registr mapovn pro CGA
         cmp       al,3                     ; je textov videomd CGA ?
         jbe       Int104                   ; je textov md CGA - OK
         mov       ah,0ah                   ; registr mapovn pro MDA
         cmp       al,7                     ; je videomd MDA ?
         je        Int104                   ; je videomd MDA
         cmp       al,19
         jbe       Int109                   ; je standardn grafick md

; ------ test, zda je textov md SVGA

         mov       dx,3ceh
         mov       al,6
         out       dx,al                    ; dic registr
         inc       dx
         in        al,dx
         mov       ah,al                    ; schova registru mdu
         and       al,0fh
         cmp       al,0eh                   ; textov md CGA
         je        Int104                   ; je textov md CGA
         cmp       al,0ah                   ; textov md MDA
         jne       Int109                   ; nen textov md
Int104:  mov       cs:[RegMap+KORIG],ah     ; schova registru pro mapovn

; ------ nastaven videoadie do reimu definice znak

         call      InitRegF                 ; inicializace registr pro fonty

; ------ stanoven adresy fontu podle potu linek na znak

         mov       cx,ds:[485h]             ; poet linek na znak
         mov       bx,offset Font8+KORIG    ; font 8x8
         cmp       cx,10
         jbe       Int105                   ; je mal poet linek na znak
         mov       bx,offset Font14+KORIG   ; font pro vt znaky

; ------ pedefinovn font

Int105:  call      Defin                    ; definovn nrodnch font

; ------ zptn nastaven videomdu

         call      InitRegT                 ; inicializace registr pro text

; ------ nvrat registr

Int109:  pop       es
         pop       ds
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         iret

Int10    ENDP

; -----------------------------------------------------------------------------
;        pedefinovn nrodnch font
; -----------------------------------------------------------------------------
; VSTUP: CS:BX=vlastn fonty
;        CX=poet linek na znak
; -----------------------------------------------------------------------------

Defin    PROC      NEAR

         mov       si,offset TabISO+KORIG   ; tabulka definice fontu
         mov       ax,0a000h                ; segment videopamti
         mov       es,ax                    ; segment videopamti
         mov       ds,ax
         mov       dh,80h                   ; poten ukazatel znak

; ------ test konce tabulky

Tabel1:  mov       ax,cs:[si]               ; definice z tabulky
         inc       si
         inc       si
         or        ax,ax                    ; je konec tabulky ?
         jnz       Tabel2                   ; nen jet konec tabulky
         ret

; ------ proveden skoku

Tabel2:  push      ax
         and       al,7                     ; dlka skoku
         add       dh,al                    ; zven sla znaku
         pop       ax

; ------ pevod znaku

         shr       al,1
         shr       al,1
         shr       al,1                     ; slo fontu (0 a 31)
         mov       dl,ah                    ; standardn znak
         call      PrevCh                   ; pevod znaku
         inc       dh                       ; zven ukazatele
         jmp       short Tabel1             ; dal font

Defin    ENDP

; -----------------------------------------------------------------------------
;     Pevod znaku
; -----------------------------------------------------------------------------
; VSTUP: ES,DS=segment videopamti
;        CS:BX=vlastn fonty
;        DL=standardn znak
;        DH=msto k uloen
;        AL=slo fontu 0 a 31
; -----------------------------------------------------------------------------
; znien registry: AX, DI
; -----------------------------------------------------------------------------

PrevCh   PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si
         mov       ah,0
         cld                                ; smr nahoru

; ------ adresa vlastnho fontu

Prevch0: dec       ax
         js        Prevch4                  ; font nalezen
         push      ax
         mov       al,cs:[bx]               ; definice fontu
         inc       bx
         and       al,0fh                   ; dlka fontu
         add       bx,ax                    ; zven adresy fontu
         pop       ax
         jmp       short Prevch0            ; dal font

; ------ adresa msta uloen znaku ES:DI

Prevch4: mov       al,32                    ; poet bajt na znak ve fontech
         mul       dh                       ; offset ve videopamti
         xchg      ax,di                    ; adresa znaku ve videopamti

; ------ adresa standardnho fontu DS:SI

         mov       al,32                    ; poet linek na znak
         mul       dl                       ; offset v tabulce stand. znak
         xchg      ax,si                    ; adresa standardnho znaku

; ------ poten a koncov linka fontu

         mov       dl,cs:[bx]               ; poten linka a dlka
         inc       bx                       ; zven adresy
         mov       dh,dl                    ; kopie do DH
         and       dl,0fh                   ; DL=dlka 0 a 15
         shr       dh,1
         shr       dh,1
         shr       dh,1
         shr       dh,1                     ; DH=poten linka 0 a 15

; ------ korekce pro fonty 16x8 a 19x8

         cmp       cl,14
         jbe       Prevch5

         cmp       cl,19
         jb        Prevch55
         or        dh,dh
         jz        PrevCh55
         add       dh,2
         cmp       dh,8
         jbe       Prevch55
         inc       dh
Prevch55:cmp       dh,8
         jb        Prevch5                  ; je v horn polovin
         add       dh,2                     ; zven pozice

; ------ korekce hornch linek pro 8x8

Prevch5: or        dl,dl                    ; je njak font ?
         jz        Prevch8                  ; nen dn font - nen korekce
         cmp       dh,4                     ; je font dole ?
         jae       Prevch8                  ; je font dole - nen korekce
         inc       si
         mov       ax,100h                  ; korekce pro font 8x8
         cmp       cl,8                     ; je font 8x8 ?
         je        Prevch7                  ; nen font 8x8
         dec       si
Prevch8: mov       ah,-1                    ; nen korekce pro ostatn znaky

; ------ pevod jednoho znaku

         mov       cx,32                    ; poet linek k pevodu
Prevch1: lodsb                              ; bajt standardnho fontu
         dec       ah                       ; korekce pro fonty 8x8
         jnz       Prevch7                  ; nen prvn bajt
         or        al,ds:[si-2]             ; + bajt z pedel linky
Prevch7: dec       dh                       ; ta poten linky
         jns       Prevch2                  ; je pod poten linkou
         dec       dl                       ; ta potu linek
         js        Prevch2                  ; je nad koncovou linkou
         or        al,cs:[bx]               ; slouen s vlatnm znakem
         inc       bx                       ; zven adresy vlastnho fontu
Prevch2: stosb                              ; uloen do videopamti
         loop      Prevch1                  ; dal bajt

; ------ nvrat registr

Prevch3: pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

PrevCh   ENDP

; -----------------------------------------------------------------------------
;     Inicializace registr videokarty na reim definice font
; -----------------------------------------------------------------------------

InitRegF PROC      NEAR

         mov       ah,2                     ; tec rovina
         mov       cx,4                     ; nastaven mapovn pro fonty
         mov       bx,407h                  ; BH=roviny, BL=prokldn
         jmp       short InitReg            ; inicializace registr

InitRegF ENDP

; -----------------------------------------------------------------------------
;        Inicializace registr videokarty na textov videomd
; -----------------------------------------------------------------------------

InitRegT PROC      NEAR

         mov       ah,0                     ; tec rovina
         mov       cl,cs:[RegMap+KORIG]     ; registr pro mapovn
         mov       ch,10h                   ; registr mdu - prokldn
         mov       bx,303h                  ; BH=roviny, BL=prokldn

InitRegT ENDP

; -----------------------------------------------------------------------------
;        Inicializace registr videokarty
; -----------------------------------------------------------------------------
; VSTUP: AH=tec rovina (0=text, 1=atributy, 2=fonty)
;        BH=roviny k zpisu (bit 0 = text, bit 1 = atributy, bit 2 = fonty)
;        BL=nastaven prokldn (3=je prokldn rovin, 7=sekvenn adresy)
;        CL=nastaven mapovn (04h=A000h, 0Ah=B000h, 0Eh=B800h)
;        CH=registr mdu (0=sekvenn adresovn, 10h=prokldan adresovn)
; -----------------------------------------------------------------------------
; znien registry: AX, DX
; -----------------------------------------------------------------------------

InitReg  PROC      NEAR

; ------ volba rovin pro zpis (maska)

         mov       dx,3c4h                  ; bzov adresa 03c4h
         mov       al,2
         out       dx,al                    ; volba registru 2
         inc       dx
         mov       al,bh                    ; roviny k zpisu
         out       dx,al                    ; nastaven rovin pro zpis

; ------ nastav. prokldn bajt sud/lich

         dec       dx
         mov       al,4
         out       dx,al                    ; volba registru 4
         inc       dx
         mov       al,bl                    ; prokldn
         out       dx,al                    ; nastaven prokldn bajt

; ------ nastaven mapovn videopamti (adresa)

         mov       dl,0ceh                  ; port 03ceh/03cfh
         mov       al,6
         out       dx,al                    ; volba registru 6
         inc       dx
         mov       al,cl                    ; nastaven mapovn
         out       dx,al                    ; nastaven mapovn videopamti

; ------ nastaven registru mdu (ten i zpis - MD 0)

         dec       dx
         mov       al,5
         out       dx,al                    ; volba registru 5
         inc       dx
         mov       al,ch                    ; registr mdu
         out       dx,al

; ------ volba roviny pro ten

         dec       dx
         mov       al,4
         out       dx,al                    ; volba registru 4
         inc       dx
         mov       al,ah                    ; rovina ke ten
         out       dx,al                    ; nastaven roviny ke ten
         ret

InitReg  ENDP

; *****************************************************************************
;                              Tabulky
; *****************************************************************************
;
font8    label     byte                     ; fonty 8x8
         db        2,0ch,18h                ; carv: rka pro velk psmena
         db        2,0ch,18h                ; carm: rka pro mal psmena
         db        2,3,3                    ; carp: rka po prav stran
         db        2,30h,18h                ; zcarv: zptn rka pro velk ps.
         db        2,30h,18h                ; zcarm: zptn rka pro mal psm.
         db        2,6ch,38h                ; hacv: hek pro velk psmena
         db        2,6ch,38h                ; hacm: hek pro mal psmena
         db        3,3,1,2                  ; hacp: hek po prav stran
         db        3,10h,28h,10h            ; krov: krouek nad velkm "U"
         db        3,38h,6ch,38h            ; krom: krouek nad malm "u"
         db        1,0feh                   ; strv: stka nad velkm psmenem
         db        32h,30h,0c0h             ; skrl: pekrtnut vlevo
         db        32h,18h,60h              ; skrs: pekrtnut uprosted
         db        21h,7eh                  ; skrp: pekrtnut vpravo
         db        2,66h,0cch               ; dvov: dvojrka nad velkm psm.
         db        2,66h,0cch               ; dvom: dvojrka nad malm psm.
         db        62h,8,0eh                ; (patr: patika vpravo)
         db        62h,10h,1eh              ; pats: patika uprosted
         db        62h,18h,78h              ; ocap: ocsek uprosted
         db        1,18h                    ; tecv: teka nad velkm psmenem
         db        1,18h                    ; tecm: teka nad malm psmenem
         db        2,0c6h,7ch               ; misv: miska nad velkm psmenem
         db        2,0c6h,7ch               ; mism: miska nad malm psmenem
         db        7,0c6h,7ch,0c6h,0c6h,0c6h,7ch,0c6h ; spc1: rubl
         db        1,66h                    ; dvot: dvojteka
         db        44h,36h,36h,12h,24h      ; dvojuvozovky dole
         db        4,36h,36h,12h,24h        ; dvojuvozovky nahoe vlevo
         db        4,12h,24h,36h,36h        ; dvojuvozovky nahoe vpravo
         db        16h,18h,7eh,18h,18h,18h,18h ; k
         db        7,62h,64h,8,10h,20h,5bh,9bh ; promile
         db        8,7eh,81h,0,0,0,0,81h,7eh ; copyright
         db        0                        ; nofn: konec tabulky


font14   label     byte                     ; fonty 8x14 a 8x16
         db        2,0ch,18h                ; carv: rka pro velk psmena
         db        13h,0ch,18h,30h          ; carm: rka pro mal psmena
         db        3,3,3,2                  ; carp: rka po prav stran
         db        2,30h,18h                ; zcarv: zptn rka pro velk ps.
         db        13h,30h,18h,0ch          ; zcarm: zptn rka pro mal psm.
         db        3,66h,3ch,18h            ; hacv: hek pro velk psmena
         db        13h,66h,3ch,18h          ; hacm: hek pro mal psmena
         db        4,3,3,1,2                ; hacp: hek po prav stran
         db        3,10h,28h,10h            ; krov: krouek nad velkm "U"
         db        13h,38h,6ch,38h          ; krom: krouek nad malm "u"
         db        2,7eh,0c3h               ; strv: stka nad velkm psmenem
         db        52h,30h,0c0h             ; skrl: pekrtnut vlevo
         db        52h,0ch,30h              ; skrs: pekrtnut uprosted
         db        31h,7eh                  ; skrp: pekrtnut vpravo
         db        2,33h,66h                ; dvov: dvojrka nad velkm psm.
         db        22h,33h,66h              ; dvom: dvojrka nad malm psm.
         db        094h,8,8,8,0eh           ; patr: (patika vpravo)
         db        094h,18h,18h,30h,1eh     ; pats: patika uprosted
         db        0a4h,18h,18h,0ch,78h     ; ocap: ocsek uprosted
         db        2,18h,18h                ; tecv: teka nad velkm psmenem
         db        22h,18h,18h              ; tecm: teka nad malm psmenem
         db        2,0c6h,7ch               ; misv: miska nad velkm psmenem
         db        22h,0c6h,7ch             ; mism: miska nad malm psmenem
         db        47h,0c6h,7ch,0c6h,0c6h,0c6h,7ch,0c6h ; spc1: rubl
         db        1,66h                    ; dvot: dvojteka
         db        94h,36h,36h,12h,24h      ; dvojuvozovky dole
         db        4,36h,36h,12h,24h        ; dvojuvozovky nahoe vlevo
         db        4,12h,24h,36h,36h        ; dvojuvozovky nahoe vpravo
         db        49h,18h,18h,7eh,18h,18h,18h,18h,18h,18h ; k
         db        3ah,60h,63h,6,0ch,18h,30h,60h,0c0h,1bh,1bh ; promile
         db        0eh,7eh,81h,0,0,0,0,0,0,0,0,0,0,81h,7eh ; copyright
         db        0                        ; nofn: konec tabulky

carv     equ       00h                      ; rka pro velk psmena
carm     equ       08h                      ; rka pro mal psmena
carp     equ       10h                      ; rka po prav stran
zcarv    equ       18h                      ; zptn rka pro velk psmena
zcarm    equ       20h                      ; zptn rka pro mal psmena
hacv     equ       28h                      ; hek pro velk psmena
hacm     equ       30h                      ; hek pro mal psmena
hacp     equ       38h                      ; hek po prav stran
krov     equ       40h                      ; krouek nad velkm "U"
krom     equ       48h                      ; krouek nad malm "u"
strv     equ       50h                      ; stka nad velkm psmenem
skrl     equ       58h                      ; pekrnut vlevo
skrs     equ       60h                      ; pekrtnut uprosted
skrp     equ       68h                      ; pekrtnut vpravo
dvov     equ       70h                      ; dvojrka nad velkm psmenem
dvom     equ       78h                      ; dvojrka nad malm psmenem
;patr     equ       80h                      ; patika vpravo (nepouzito !!!!)
pats     equ       88h                      ; patika uprosted
ocap     equ       90h                      ; ocsek uprosted
tecv     equ       98h                      ; teka nad velkm psmenem
tecm     equ       0a0h                     ; teka nad malm psmenem
misv     equ       0a8h                     ; miska nad velkm psmenem
mism     equ       0b0h                     ; miska nad malm psmenem
spc1     equ       0b8h                     ; speciln znak - rubl
dvot     equ       0c0h                     ; dvojteka
dvud     equ       0c8h                     ; dvojuvozovky dole
dvul     equ       0d0h                     ; dvojuvozovky nahoe vlevo
dvur     equ       0d8h                     ; dvojuvozovky nahoe vpravo
kriz     equ       0e0h                     ; k
prom     equ       0e8h                     ; promile
kolo     equ       0f0h                     ; velk kolo (copyright atd.)

nofn     equ       0f8h                     ; konec tabulky

TabISO   label     byte                     ; definin tabulka ISO
         db        nofn,218                 ; 128: ""
         db        nofn,191                 ; 129: ""
         db        nofn,192                 ; 130: ""
         db        nofn,217                 ; 131: ""
         db        nofn,194                 ; 132: ""
         db        nofn,180                 ; 133: ""
         db        nofn,193                 ; 134: ""
         db        nofn,195                 ; 135: ""
         db        nofn,197                 ; 136: ""
         db        nofn,179                 ; 137: ""
         db        nofn,196                 ; 138: ""
         db        nofn,176                 ; 139: ""
         db        nofn,' '                 ; 140: " "
         db        nofn,177                 ; 141: ""
         db        nofn,178                 ; 142: ""
         db        nofn,219                 ; 143: ""
         db        nofn,223                 ; 144: ""
         db        nofn,220                 ; 145: ""
         db        nofn,174                 ; 146: ""  ???
         db        nofn,'x'                 ; 147: "x"  ???
         db        nofn,'-'                 ; 148: "-"  ???
         db        nofn,254                 ; 149: ""
         db        nofn,' '                 ; 150: " "
         db        nofn,' '                 ; 151: " "
         db        nofn,' '                 ; 152: " "
         db        nofn,' '                 ; 153: " "
         db        nofn,' '                 ; 154: " "
         db        nofn,' '                 ; 155: " "
         db        nofn,' '                 ; 156: " "
         db        nofn,' '                 ; 157: " "
         db        nofn,' '                 ; 158: " "
         db        nofn,' '                 ; 159: " "
         db        nofn,' '                 ; 160: " "
         db        pats,'A'                 ; 161: "A" s patikou
         db        misv,' '                 ; 162: miska nad velkm psmenem
         db        skrl,'L'                 ; 163: "L" pekrtnut
         db        spc1,' '                 ; 164: rubl
         db        hacp,'L'                 ; 165: "L" s hkem
         db        carv,'S'                 ; 166: "S" s rkou
         db        nofn,21                  ; 167: paragraf
         db        dvot,' '                 ; 168: dvojteka nad znakem
         db        hacv,'S'                 ; 169: "S" s hkem
         db        ocap,'S'                 ; 170: "S" s ocskem
         db        hacv,'T'                 ; 171: "T" s hkem
         db        carv,'Z'                 ; 172: "Z" s rkou
         db        nofn,' '                 ; 173: " "
         db        hacv,'Z'                 ; 174: "Z" s hkem
         db        tecv,'Z'                 ; 175: "Z" s tekou
         db        nofn,248                 ; 176: ""
         db        pats,'a'                 ; 177: "a" s patikou
         db        pats,' '                 ; 178: patika
         db        skrs,'l'                 ; 179: "l" pekrtnut
         db        carm,' '                 ; 180: rka vpravo
         db        hacp,'l'                 ; 181: "l" s hkem
         db        carm,'s'                 ; 182: "s" s rkou
         db        hacm,' '                 ; 183: hek nad malm psmenem
         db        ocap,' '                 ; 184: ocsek
         db        hacm,'s'                 ; 185: "s" s hkem
         db        ocap,'s'                 ; 186: "s" s ocskem
         db        hacp,'t'                 ; 187: "t" s hkem
         db        carm,'z'                 ; 188: "z" s rkou
         db        dvom,' '                 ; 189: dvojrka
         db        hacm,'z'                 ; 190: "z" s hkem
         db        tecm,'z'                 ; 191: "z" s tekou
         db        carv,'R'                 ; 192: "R" s rkou
         db        carv,'A'                 ; 193: "A" s rkou
         db        strv,'A'                 ; 194: "A" se stkou
         db        misv,'A'                 ; 195: "A" s miskou
         db        dvot,'A'                 ; 196: "A" s dvojtekou
         db        carv,'L'                 ; 197: "L" s rkou
         db        carv,'C'                 ; 198: "C" s rkou
         db        ocap,'C'                 ; 199: "C" s ocskem
         db        hacv,'C'                 ; 200: "C" s hkem
         db        carv,'E'                 ; 201: "E" s rkou
         db        pats,'E'                 ; 202: "E" s patikou
         db        dvot,'E'                 ; 203: "E" s dvojtekou
         db        hacv,'E'                 ; 204: "E" s hkem
         db        carv,'I'                 ; 205: "I" s rkou
         db        strv,'I'                 ; 206: "I" se stkou
         db        hacv,'D'                 ; 207: "D" s hkem
         db        skrl,'D'                 ; 208: "D" pekrtnut
         db        carv,'N'                 ; 209: "N" s rkou
         db        hacv,'N'                 ; 210: "N" s hkem
         db        carv,'O'                 ; 211: "O" s rkou
         db        strv,'O'                 ; 212: "O" se stkou
         db        dvov,'O'                 ; 213: "O" s dvojrkou
         db        dvot,'O'                 ; 214: "O" s dvojtekou
         db        nofn,'x'                 ; 215: pekrtnut
         db        hacv,'R'                 ; 216: "R" s hkem
         db        krov,'U'                 ; 217: "U" s kroukem
         db        carv,'U'                 ; 218: "U" s rkou
         db        dvov,'U'                 ; 219: "U" s dvojrkou
         db        dvot,'U'                 ; 220: "U" s dvojtekou
         db        carv,'Y'                 ; 221: "Y" s rkou
         db        ocap,'T'                 ; 222: "T" s ocskem
         db        nofn,''                 ; 223: "" - beta
         db        carm,'r'                 ; 224: "r" s rkou
         db        carm,'a'                 ; 225: ""
         db        strv,'a'                 ; 226: "a" se stkou
         db        mism,'a'                 ; 227: "a" s miskou
         db        dvot,'a'                 ; 228: "a" s dvojtekou
         db        carv,'l'                 ; 229: "l" s rkou
         db        carm,'c'                 ; 230: "c" s rkou
         db        ocap,'c'                 ; 231: "c" s ocskem
         db        hacm,'c'                 ; 232: "c" s hkem
         db        carm,'e'                 ; 233: "e" s rkou
         db        pats,'e'                 ; 234: "e" s patikou
         db        dvot,'e'                 ; 235: "e" s dvojtekou
         db        hacm,'e'                 ; 236: "e" s hkem
         db        carm,'i'                 ; 237: ""
         db        strv,'i'                 ; 238: "i" se stkou
         db        hacp,'d'                 ; 239: "d" s hkem
         db        skrp,'d'                 ; 240: "d" pekrtnut
         db        carm,'n'                 ; 241: "n" s rkou
         db        hacm,'n'                 ; 242: "n" s hkem
         db        carm,'o'                 ; 243: "o" s rkou
         db        strv,'o'                 ; 244: "o" se stkou
         db        dvom,'o'                 ; 245: "o" s dvojrkou
         db        dvot,'o'                 ; 246: "o" s dvojtekou
         db        nofn,':'                 ; 247: ""
         db        hacm,'r'                 ; 248: "r" s hkem
         db        krom,'u'                 ; 249: "u" s kroukem
         db        carm,'u'                 ; 250: "u" s rkou
         db        dvom,'u'                 ; 251: "u" s dvojrkou
         db        dvot,'u'                 ; 252: "u" s dvojtekou
         db        carm,'y'                 ; 253: "y" s rkou
         db        ocap,'t'                 ; 254: "t" s ocskem
         db        tecv,' '                 ; 255: teka nad velkm psmenem
         dw        0

TabISO0  label     byte

; *****************************************************************************
;                         Instalace programu
; *****************************************************************************
;
; ------ instalace INT 23h

Instal:  mov       dx,offset Int23          ; obsluha INT 23h
         mov       ax,2523h
         int       21h                      ; instalace obsluhy INT 23h

; ------ schova pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       di,offset Command        ; buffer pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld
         rep       movsb                    ; scova pkazovho dku
         mov       ds:[di],ch               ; oznaen konce pkazovho dku

; ------ posun programu dol

         mov       si,offset ZacRez         ; star zatek rezidentn sti
         mov       di,offset ZacRez+KORIG   ; nov zatek rezidentn sti
         mov       cx,offset(Instal-ZacRez) ; dlka rezidentn sti
         rep       movsb                    ; posun programu dol

; ------ test, zda je program ji nainstalovn

         mov       ax,KLIC1
         mov       bx,KLIC2
         mov       cx,KLIC3
         int       10h                      ; test instalace programu
         cmp       cx,KLIC4
         je        Inst11                   ; program je jiz nainstalovan
         push      cs
         pop       es
         or        byte ptr ds:[ParamIns],1 ; pznak prvn instalace
Inst11:  mov       ds:[SegRez],es           ; rezidentn segment

; ------ test karty EGA/VGA

         mov       ah,12h                   ; funkce informac EGA
         mov       bx,3e10h                 ; podfunkce - test instalace
         int       10h                      ; informace o kart EGA
         cmp       bh,1
         ja        Chyba1                   ; nen karta EGA/VGA
         cmp       bl,6                     ; kontrola navrcenho daje
         jb        Instal1                  ; je displej EGA/VGA

; ------ chyba - nen karta EGA/VGA

Chyba1:  mov       dx,offset ErrTxt         ; chyba - nen karta EGA/VGA

; ------ zobrazen vodnho textu a chybovho hlen

Chyba:   push      dx
         mov       dx,offset UvTxt          ; vodn text
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu
         pop       dx

         mov       ah,9
         int       21h                      ; zobrazen chybovho hlen
         int       20h

; ------ pprava k dekdovn pkazovho dku

Instal1: mov       es,ds:[SegRez]           ; segment rezidentn sti
         mov       si,offset Command        ; zatek pkazovho dku

; ------ nalezen zatku parametru

Instal3: call      ParSpc                   ; vyputn mezer
         jc        Instal6                  ; konec parametr
         call      ParChr
         cmp       al,"/"
         je        Instal3                  ; ignorovn znaku "/"
         cmp       al,"-"
         je        Instal3                  ; ignorovn znaku "-"
         call      Param                    ; dekdovn parametru
         mov       dx,offset HelpTxt        ; text npovdy
         jc        Chyba                    ; chyba zadn parametr

; ------ test, zda se poaduje odinstalovn programu

Instal6: test      byte ptr ds:[ParamIns],2 ; poaduje se odinstalovn ?
         jz        Instal7                  ; nepoaduje se odinstalovn

; ------ test, zda je nainstalovn

         mov       dx,offset NeniTxt        ; text - nen nainstalovn
         test      byte ptr ds:[ParamIns],1 ; je to prvn instalace ?
         jnz       Chyba                    ; chyba - nebyl dosud nainstalovn

; ------ test, zda lze odinstalovat

         mov       ax,3510h
         int       21h                      ; poskytnut adresy INT 10h
         mov       dx,offset NelzeTxt       ; text - nelze odinstalovat
         mov       ax,es
         cmp       ax,ds:[SegRez]           ; souhlas adresa ?
         jne       Chyba                    ; chyba - nelze odinstalovat

; ------ nvrat vektoru INT 10h

         push      ds
         lds       dx,es:[Old10+KORIG]      ; pvodn adresa INT 10h
         mov       ax,2510h
         int       21h                      ; nvrat adresy INT 10h
         pop       ds

; ------ uvolnn segmentu programu

         mov       ah,49h
         int       21h                      ; uvolnn segmentu ES

; ------ hlen o odinstalovn

         mov       dx,offset OdInsTxt       ; text - byl odinstalovn
         jmp       short Chyba              ; hlen o odindstalovn

; ------ kontrola, zda je to prvn instalace

Instal7: test      byte ptr ds:[ParamIns],1 ; je to prvn instalace ?
         jnz       Instal8                  ; je to prvn instalace
         call      Inform                   ; inicializace videomdu + hlen
         int       20h                      ; jinak konec

; ------ schova pvodn adresy INT 10h

Instal8: push      es
         mov       ax,3510h
         int       21h
         mov       word ptr ds:[Old10+KORIG],bx ; schova offsetu INT 10h
         mov       word ptr ds:[Old10+2+KORIG],es ; schova segmentu INT 10h

; ------ instalace nov obsluhy INT 10h

         mov       dx,offset Int10+KORIG    ; vlastn obsluha INT 10h
         mov       ax,2510h
         int       21h                      ; instalace vlastn obsluhy INT 10h

; ------ uvolnn pamovho bloku segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h                   ; funkce uvolnn pamti
         int       21h                      ; uvolnn bloku pamti
         pop       es

; ------ inicializace videomdu

         or        byte ptr ds:[ParamIns],4 ; pznak zmny kdu
         call      Inform                   ; inicializace videomdu + hlen

; ------ instalace programu

         mov       dx,offset Instal         ; konec rezidentn sti
         int       27h                      ; instalace programu

; -----------------------------------------------------------------------------
;        obsluha INT 23h
; -----------------------------------------------------------------------------

Int23    PROC      FAR

         iret

Int23    ENDP

; -----------------------------------------------------------------------------
;        dekdovn jednoho parametru AL
; -----------------------------------------------------------------------------

Param    PROC      NEAR

; ------ parametr "K" - kd Kamenickch

         mov       ah,1                     ; slo kdu Kamenickch
         cmp       al,"K"                   ; kd Kamenickch ?
         je        Param1                   ; je kd Kamenickch

; ------ parametr "L" - kd Latin 2

         mov       ah,2                     ; slo kdu Latin 2
         cmp       al,"L"                   ; kd Latin 2 ?
         je        Param1                   ; je kd Latin 2

; ------ parametr "I" - kd KOI 8

         mov       ah,3                     ; slo kdu KOI 8
         cmp       al,"I"                   ; kd KOI 8 ?
         je        Param1                   ; je kd KOI 8

; ------ parametr "O" - kd ISO 8859/2

         mov       ah,4                     ; slo kdu ISO 8859/2
         cmp       al,"O"                   ; kd ISO 8859/2
         je        Param1                   ; je kd ISO 8859/2

; ------ parametr "W" - kd WINDOWS

         mov       ah,5                     ; kd WINDOWS
         cmp       al,"W"
         je        Param1                   ; je kd WINDOWS

; ------ parametr "M" - kd Latin 2 mini

         mov       ah,6
         cmp       al,"M"                   ; Latin 2 mini
         je        Param1

; ------ parametr "0" - vypnut font

         mov       ah,0                     ; slo kdu IBM
         cmp       al,"0"                   ; vypnut obsluhy ?
         jne       Param2                   ; nen vypnut funkce

; ------ nastaven sla poadovanho fontu

Param1:  cmp       byte ptr es:[FontTab+KORIG],ah ; mn se kd ?
         je        Param12                  ; kd se nemn
         or        byte ptr ds:[ParamIns],4 ; pznak zmny kdu
         mov       es:[FontTab+KORIG],ah    ; nastaven sla kdu
Param12: clc
         ret

; ------ parametr "!" - odinstalovn z pamti

Param2:  cmp       al,"!"                   ; odinstalovn ?
         jne       Param3                   ; chyba zadn
         or        byte ptr ds:[ParamIns],2 ; pznak odinstalovn
         ret

Param3:  stc                                ; pznak chyby
         ret

Param    ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z pkazovho dku
; -----------------------------------------------------------------------------

ParSpc   PROC      NEAR

         call      ParChr
         jc        ParSpc2
         je        ParSpc
         dec       si
ParSpc2: ret

ParSpc   ENDP

; -----------------------------------------------------------------------------
;        vstup znaku z pkazovho dku
; -----------------------------------------------------------------------------

ParChr   PROC      NEAR

         cld
         lodsb
         cmp       al,"a"
         jb        ParChr1
         cmp       al,"z"
         ja        ParChr1
         sub       al,32
ParChr1: cmp       al,9
         jne       ParChr2
         mov       al," "
ParChr2: cmp       al," "
         jae       ParChr3
         dec       si
ParChr3: ret

ParChr   ENDP

; -----------------------------------------------------------------------------
;        zobrazen informanho textu (ES=segment programu)
; -----------------------------------------------------------------------------

Inform   PROC      NEAR

; ------ test, zda byla zmna kdu

         test      byte ptr ds:[ParamIns],4 ; byla zmna kdu ?
         jz        Inform2                  ; nebyla zmna kdu

; ------ stanoven adresy font

         mov       ah,0
         mov       al,es:[FontTab+KORIG]    ; slo tabulky font
         mov       si,offset TabKam         ; etina Kamenickch
         dec       ax                       ; je etina Kamenickch ?
         jz        Inform1                  ; etina Kamenickch
         mov       si,offset TabLat         ; etina Latin 2
         dec       ax                       ; je etina Latin 2 ?
         jz        Inform1                  ; je etina Latin 2
         mov       si,offset TabKoi         ; etina KOI 8
         dec       ax                       ; je etina KOI 8 ?
         jz        Inform1                  ; je etina KOI 8
         mov       si,offset TabISO+KORIG   ; ISO 8859/2
         dec       ax                       ; je ISO 2 ?
         jz        Inform1                  ; je ISO 2
         mov       si,offset TabWIN         ; WINDOWS
         dec       ax
         jz        Inform1
         mov       si,offset TabMin         ; Latin 2 mini

; ------ penos tabulky font

Inform1: cld
         mov       cx,offset(TabISO0-TabISO) ; dlka tabulky
         mov       di,offset TabISO+KORIG
         rep       movsb                    ; penos tabulky

; ------ prvn instalace videomdu

         test      byte ptr ds:[ParamIns],1 ; je prvn instalace ?
         jz        Inform12                 ; nen prvn instalace

         pushf
         push      cs
         call      near ptr Int1032+KORIG   ; instalace font
         jmp       short Inform2

; ------ peinstalovn videomdu

Inform12:push      es
         mov       ah,0fh
         int       10h                      ; poskytnut aktivnho videomdu
         mov       ah,0
         int       10h                      ; peinstalovn videomdu
         pop       es

; ------ zobrazen vodnho textu

Inform2: mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ hlen, e byl nainstalovn

         test      byte ptr ds:[ParamIns],1 ; je prvn instalace ?
         jz        Inform3                  ; nen prvn instalace
         mov       dx,offset InstTxt        ; text - byl nainstalovn
         mov       ah,9
         int       21h                      ; hlen o nainstalovn programu

; ------ zobrazen hlen o aktivnm kdu

Inform3: mov       ah,0
         mov       al,es:[FontTab+KORIG]    ; slo tabulky font
         mov       dx,offset UvTxtK         ; etina Kamenickch
         dec       ax                       ; je etina Kamenickch ?
         jz        Inform4                  ; etina Kamenickch
         mov       dx,offset UvTxtL         ; etina Latin 2
         dec       ax                       ; je etina Latin 2 ?
         jz        Inform4                  ; je etina Latin 2
         mov       dx,offset UvTxtI         ; etina KOI 8
         dec       ax                       ; je etina KOI 8 ?
         jz        Inform4                  ; je etina KOI 8
         mov       dx,offset UvTxtO         ; etina ISO 8859/2
         dec       ax                       ; je etina ISO 8859/2 ?
         jz        Inform4                  ; je etina ISO 8859/2
         mov       dx,offset UvTxtW         ; WINDOWS
         dec       ax
         jz        Inform4
         mov       dx,offset UvTxtM         ; Latin 2 mini
         dec       ax
         jz        Inform4
         mov       dx,offset UvTxt0         ; etina vypnuta
Inform4: mov       ah,9
         int       21h                      ; zobrazen textu o stavu
         ret

Inform   ENDP

; -----------------------------------------------------------------------------
;                                  data
; -----------------------------------------------------------------------------
;

SegRez   dw        0                        ; sezidentn segment

ParamIns db        0                        ; parametry pro instalaci
                                            ;   bit 0: 1=je prvn instalace
                                            ;   bit 1: 1=poadavek odinstalovn
                                            ;   bit 2: 1=byla zmna kdu

ErrTxt   db        'Neni nainstalovana karta EGA/VGA !',13,10,'$'

HelpTxt  db        'Zadejte: K ...... kod Kamenickych (KEYBCS2)',13,10
         db        '         L ...... kod Latin 2',13,10
         db        '         M ...... kod Latin 2 minimalizovany',13,10
         db        '         I ...... kod KOI 8',13,10
         db        '         W ...... kod WINDOWS (ISO 8859)',13,10
         db        '         O ...... kod ISO 8859/2',13,10
         db        '         0 ...... kod IBM',13,10
         db        '         ! ...... odinstalovani z pameti',13,10
         db        '$'

UvTxt    db        'EGACS V3.30 - CS fonty pro EGA/VGA; (c) Miroslav Nemecek',13,10,'$'

InstTxt  db        'EGACS byl nainstalovan: $'

UvTxtK   db        'Aktivn kd Kamenickch.',13,10,'$'
UvTxtL   db        'Aktivn kd Latin 2.',13,10,'$'
UvTxtM   db        'Aktivn kd Latin 2 - minimalizovan.',13,10,'$'
UvTxtI   db        'Aktivn kd KOI 8.',13,10,'$'
UvTxtW   db        'Aktivn kd WINDOWS (ISO 8859).',13,10,'$'
UvTxtO   db        'Aktivn kd ISO 8859/2.',13,10,'$'
UvTxt0   db        'Aktivni kod IBM.',13,10,'$'

OdInsTxt db        'EGACS byl odinstalovan z pameti.',13,10,'$'
NelzeTxt db        'EGACS nelze odinstalovat !',13,10,'$'
NeniTxt  db        'EGACS nebyl dosud nainstalovan !',13,10,'$'

TabKam   label     byte                     ; definin tabulka Kamenickch
         db        hacv,'C'                 ; "C" s hkem
         db        carm+1,'e'               ; "e" s rkou
         db        hacp,'d'                 ; "d" s hkem
         db        hacv+1,'D'               ; "D" s hkem
         db        hacv,'T'                 ; "T" s hkem
         db        hacm,'c'                 ; "c" s hkem
         db        hacm,'e'                 ; "e" s hkem
         db        hacv,'E'                 ; "E" s hkem
         db        carv,'L'                 ; "L" s rkou
         db        carv,'I'                 ; "I" s rkou
         db        hacp,'l'                 ; "l" s hkem
         db        carv,'l'                 ; "l" s rkou
         db        carv+1,'A'               ; "A" s rkou
         db        carv,'E'                 ; "E" s rkou
         db        hacm,'z'                 ; "z" s hkem
         db        hacv,'Z'                 ; "Z" s hkem
         db        carv+2,'O'               ; "O" s rkou
         db        krom,'u'                 ; "u" s kroukem
         db        carv,'U'                 ; "U" s rkou
         db        carm,'y'                 ; "y" s rkou
         db        hacv+2,'S'               ; "S" s hkem
         db        hacp,'L'                 ; "L" s hkem
         db        carv,'Y'                 ; "Y" s rkou
         db        hacv,'R'                 ; "R" s hkem
         db        hacp,'t'                 ; "t" s hkem
         db        carm,'a'                 ; "a" s rkou
         db        carm+1,'o'               ; "o" s rkou
         db        carm,'u'                 ; "u" s rkou
         db        hacm,'n'                 ; "n" s hkem
         db        hacv,'N'                 ; "N" s hkem
         db        krov,'U'                 ; "U" s kroukem
         db        strv,'O'                 ; "O" se stkou
         db        hacm,'s'                 ; "s" s hkem
         db        hacm,'r'                 ; "r" s hkem
         db        carm,'r'                 ; "r" s rkou
         db        carv,'R'                 ; "R" s rkou
         db        nofn+1,21                ; paragraf
         dw        0
TabKam0  label     byte

TabLat   label     byte                     ; definin tabulka Latin 2
         db        carm+2,'e'               ; "e" s rkou
         db        krom+2,'u'               ; "u" s kroukem
         db        carm,'c'                 ; "c" s rkou
         db        ocap,'c'                 ; "c" s ocskem
         db        skrs,'l'                 ; "l" pekrtnut
         db        dvov+1,'O'               ; "O" s dvojrkou
         db        dvom,'o'                 ; "o" s dvojrkou
         db        carv+1,'Z'               ; "Z" s rkou
         db        carv+1,'C'               ; "C" s rkou
         db        carv,'E'                 ; "E" s rkou
         db        carv,'L'                 ; "L" s rkou
         db        carv,'l'                 ; "l" s rkou
         db        hacp+2,'L'               ; "L" s hkem
         db        hacp,'l'                 ; "l" s hkem
         db        carv,'S'                 ; "S" s rkou
         db        carm,'s'                 ; "s" s rkou
         db        hacv+2,'T'               ; "T" s hkem
         db        hacp,'t'                 ; "t" s hkem
         db        skrl,'L'                 ; "L" pekrtnut
         db        nofn,'x'                 ; pekrtnut
         db        hacm,'c'                 ; "c" s hkem
         db        carm,'a'                 ; "a" s rkou
         db        carm+1,'o'               ; "o" s rkou
         db        carm,'u'                 ; "u" s rkou
         db        pats,'A'                 ; "A" s patikou
         db        pats,'a'                 ; "a" s patikou
         db        hacv,'Z'                 ; "Z" s hkem
         db        hacm,'z'                 ; "z" s hkem
         db        pats,'E'                 ; "E" s patikou
         db        pats,'e'                 ; "e" s patikou
         db        carm+1,'z'               ; "z" s rkou
         db        hacv,'C'                 ; "C" s hkem
         db        ocap,'s'                 ; "s" s ocskem
         db        carv+7,'A'               ; "A" s rkou
         db        strv,'A'                 ; "A" se stkou
         db        hacv,'E'                 ; "E" s hkem
         db        ocap,'S'                 ; "S" s ocskem
         db        tecv+4,'Z'               ; "Z" s tekou
         db        tecm,'z'                 ; "z" s tekou
         db        misv+7,'A'               ; "A" s miskou
         db        mism,'a'                 ; "a" s miskou
         db        spc1+7,' '               ; rubl
         db        skrp,'d'                 ; "d" pekrtnut
         db        skrl,'D'                 ; "D" pekrtnut
         db        hacv,'D'                 ; "D" s hkem
         db        dvot,'E'                 ; "E" dvojteka
         db        hacp,'d'                 ; "d" s hkem
         db        hacv,'N'                 ; "N" s hkem
         db        carv,'I'                 ; "I" s rkou
         db        strv,'I'                 ; "I" se stkou
         db        hacm,'e'                 ; "e" s hkem
         db        ocap+4,'T'               ; "T" s ocskem
         db        krov,'U'                 ; "U" s kroukem
         db        carv+1,'O'               ; "O" s rkou
         db        strv+1,'O'               ; "O" se stkou
         db        carv,'N'                 ; "N" s rkou
         db        carm,'n'                 ; "n" s rkou
         db        hacm,'n'                 ; "n" s hkem
         db        hacv,'S'                 ; "S" s hkem
         db        hacm,'s'                 ; "s" s hkem
         db        carv,'R'                 ; "R" s rkou
         db        carv,'U'                 ; "U" s rkou
         db        carm,'r'                 ; "r" s rkou
         db        dvov,'U'                 ; "U" s dvojrkou
         db        carm,'y'                 ; "y" s rkou
         db        carv,'Y'                 ; "Y" s rkou
         db        ocap,'t'                 ; "t" s ocskem
         db        carm,' '                 ; rka vpravo
         db        nofn,'-'                 ; pomlka
         db        dvom,' '                 ; dvojrka
         db        pats,' '                 ; patika
         db        hacm,' '                 ; hek
         db        mism,' '                 ; miska
         db        nofn,21                  ; paragraf
         db        ocap+1,' '               ; ocsek
         db        krom,' '                 ; krouek
         db        dvot,' '                 ; dvojteka
         db        dvom+1,'u'               ; "u" s dvojrkou
         db        hacv,'R'                 ; "R" s hkem
         db        hacm,'r'                 ; "r" s hkem
         dw        0
TabLat0  label     byte

TabMin   label     byte                     ; minimalizovan Latin 2
         db        carm+2,'e'               ; 130: "e" s rkou
         db        krom+2,'u'               ; 133: "u" s kroukem
         db        nofn+3,137               ; 137:     (jen pro peskok)
         db        carv+6,'E'               ; 144: "E" s rkou
         db        carv,'L'                 ; 145: "L" s rkou
         db        carv,'l'                 ; 146: "l" s rkou
         db        hacp+2,'L'               ; 149: "L" s hkem
         db        hacp,'l'                 ; 150: "l" s hkem
         db        hacv+4,'T'               ; 155: "T" s hkem
         db        hacp,'t'                 ; 156: "t" s hkem
         db        nofn+1,'x'               ; 158: pekrtnut
         db        hacm,'c'                 ; 159: "c" s hkem
         db        carm,'a'                 ; 160: "a" s rkou
         db        carm+1,'o'               ; 162: "o" s rkou
         db        carm,'u'                 ; 163: "u" s rkou
         db        hacv+2,'Z'               ; 166: "Z" s hkem
         db        hacm,'z'                 ; 167: "z" s hkem
         db        hacv+4,'C'               ; 172: "C" s hkem
         db        nofn+3,176               ; 176:     (jen pro peskok)
         db        carv+4,'A'               ; 181: "A" s rkou
         db        hacv+1,'E'               ; 183: "E" s hkem
         db        nofn+7,191               ; 191:     (jen pro peskok)
         db        nofn+7,199               ; 199:     (jen pro peskok)
         db        nofn+7,207               ; 207:     (jen pro peskok)
         db        hacv+2,'D'               ; 210: "D" s hkem
         db        hacp+1,'d'               ; 212: "d" s hkem
         db        hacv,'N'                 ; 213: "N" s hkem
         db        carv,'I'                 ; 214: "I" s rkou
         db        hacm+1,'e'               ; 216: "e" s hkem
         db        krov+5,'U'               ; 222: "U" s kroukem
         db        carv+1,'O'               ; 224: "O" s rkou
         db        strv+1,'O'               ; 226: "O" se stkou
         db        hacm+2,'n'               ; 229: "n" s hkem
         db        hacv,'S'                 ; 230: "S" s hkem
         db        hacm,'s'                 ; 231: "s" s hkem
         db        carv,'R'                 ; 232: "R" s rkou
         db        carv,'U'                 ; 233: "U" s rkou
         db        carm,'r'                 ; 234: "r" s rkou
         db        carm+1,'y'               ; 236: "y" s rkou
         db        carv,'Y'                 ; 237: "Y" s rkou
         db        nofn+7,21                ; 245: paragraf
         db        hacv+6,'R'               ; 252: "R" s hkem
         db        hacm,'r'                 ; 253: "r" s hkem
         dw        0
TabMin0  label     byte


TabKoi   label     byte                     ; definin tabulka KOI 8
         db        nofn+1,151               ; 129: "u" se zptnou rkou
         db        nofn,138                 ; 130: "e" se zptnou rkou
         db        nofn,21                  ; 131: paragraf
         db        nofn,225                 ; 132: beta
         db        nofn,156                 ; 133: libra
         db        nofn,146                 ; 134: "A" ve vichru
         db        nofn,237                 ; 135: krtnut nekoneno
         db        nofn,143                 ; 136: "A" s kroukem
         db        nofn,145                 ; 137: "z" pokroucen
         db        nofn,237                 ; 138: krtnut nekoneno
         db        krom,'a'                 ; 139: "a" s kroukem
         db        nofn+1,176               ; 141: ""
         db        spc1,' '                 ; 142: rubl
         db        nofn,149                 ; 143: "o" se zptnou rkou
         db        zcarm,'i'                ; 144: "i" se zptnou rkou
         db        nofn,158                 ; 145: "Pt"
         db        nofn,173                 ; 146: obrcen vykink
         db        nofn,165                 ; 147: "N" s vlnovkou
         db        nofn,168                 ; 148: obrcen otaznk
         db        nofn,164                 ; 149: "n" s vlnovkou
         db        nofn,219                 ; 150: ""
         db        nofn,220                 ; 151: ""
         db        nofn,223                 ; 152: ""
         db        nofn,186                 ; 153: ""
         db        nofn,187                 ; 154: ""
         db        nofn,188                 ; 155: ""
         db        nofn,200                 ; 156: ""
         db        nofn,201                 ; 157: ""
         db        nofn,205                 ; 158: ""
         db        nofn,177                 ; 159: ""
         db        nofn,240                 ; 160: ""
         db        nofn,241                 ; 161: ""
         db        nofn,242                 ; 162: ""
         db        nofn,243                 ; 163: ""
         db        nofn,244                 ; 164: ""
         db        nofn,245                 ; 165: ""
         db        nofn,246                 ; 166: ""
         db        nofn,247                 ; 167: ""
         db        nofn,248                 ; 168: ""
         db        nofn,251                 ; 169: ""
         db        nofn,253                 ; 170: ""
         db        nofn+2,21                ; 173: paragraf
         db        nofn+2,224               ; 176: ""
         db        nofn,225                 ; 177: ""
         db        nofn,226                 ; 178: ""
         db        nofn,227                 ; 179: ""
         db        nofn,228                 ; 180: ""
         db        nofn,229                 ; 181: ""
         db        nofn,230                 ; 182: ""
         db        nofn,231                 ; 183: ""
         db        nofn,232                 ; 184: ""
         db        nofn,233                 ; 185: ""
         db        nofn,234                 ; 186: ""
         db        nofn,235                 ; 187: ""
         db        nofn,236                 ; 188: ""
         db        nofn,237                 ; 189: ""
         db        nofn,238                 ; 190: ""
         db        nofn,239                 ; 191: ""
         db        nofn,'+'                 ; 192: ""
         db        carm,'a'                 ; 193: ""
         db        nofn,'+'                 ; 194: ""
         db        hacm,'c'                 ; 195: "c" s hkem
         db        hacp,'d'                 ; 196: "d" s hkem
         db        hacm,'e'                 ; 197: "e" s hkem
         db        carm,'r'                 ; 198: "r" s rkou
         db        nofn,'-'                 ; 199: ""
         db        dvot,'u'                 ; 200: ""
         db        carm,'i'                 ; 201: ""
         db        krom,'u'                 ; 202: "u" s kroukem
         db        carv,'l'                 ; 203: "l" s rkou
         db        hacp,'l'                 ; 204: "l" s hkem
         db        dvot,'o'                 ; 205: "o" s dvojtekou
         db        hacm,'n'                 ; 206: "n" s hkem
         db        carm,'o'                 ; 207: "o" s rkou
         db        strv,'o'                 ; 208: "o" se stkou
         db        dvot,'a'                 ; 209: "a" s dvojtekou
         db        hacm,'r'                 ; 210: "r" s hkem
         db        hacm,'s'                 ; 211: "s" s hkem
         db        hacp,'t'                 ; 212: "t" s hkem
         db        carm,'u'                 ; 213: "u" s rkou
         db        nofn,'+'                 ; 214: ""
         db        carm,'e'                 ; 215: "e" s rkou
         db        zcarm,'a'                ; 216: "a" se zptnou rkou
         db        carm,'y'                 ; 217: "y" s rkou
         db        hacm,'z'                 ; 218: "z" s hkem
         db        nofn,'+'                 ; 219: ""
         db        nofn+1,223               ; 221: ""
         db        nofn,'='                 ; 222: ""
         db        nofn,'+'                 ; 223: ""
         db        nofn,'+'                 ; 224: ""
         db        carv,'A'                 ; 225: "A" s rkou
         db        nofn,'+'                 ; 226: ""
         db        hacv,'C'                 ; 227: "C" s hkem
         db        hacv,'D'                 ; 228: "D" s hkem
         db        hacv,'E'                 ; 229: "E" s hkem
         db        carv,'R'                 ; 230: "R" s rkou
         db        nofn,'|'                 ; 231: ""
         db        dvot,'U'                 ; 232: ""
         db        carv,'I'                 ; 233: "I" s rkou
         db        krov,'U'                 ; 234: "U" s kroukem
         db        carv,'L'                 ; 235: "L" s rkou
         db        hacp,'L'                 ; 236: "L" s hkem
         db        dvot,'O'                 ; 237: "O" s dvojtekou
         db        hacv,'N'                 ; 238: "N" s hkem
         db        carv,'O'                 ; 239: "O" s rkou
         db        strv,'O'                 ; 240: "O" se stkou
         db        dvot,'A'                 ; 241: "A" s dvojtekou
         db        hacv,'R'                 ; 242: "R" s hkem
         db        hacv,'S'                 ; 243: "S" s hkem
         db        hacv,'T'                 ; 244: "T" s hkem
         db        carv,'U'                 ; 245: "U" s rkou
         db        nofn,'+'                 ; 246: ""
         db        carv,'E'                 ; 247: "E" s rkou
         db        zcarv,'A'                ; 248: "A" se zptnou rkou
         db        carv,'Y'                 ; 249: "Y" s rkou
         db        hacv,'Z'                 ; 250: "Z s hkem
         db        nofn,'+'                 ; 251: ""
         db        nofn+1,'.'
         dw        0
TabKoi0  label     byte

TabWIN   label     byte                     ; definin tabulka WINDOWS
         db        nofn,218                 ; 128: "" (nhradn graf. znak)
         db        nofn,191                 ; 129: "" (nhradn graf. znak)
         db        nofn,','                 ; 130: ","
         db        nofn,217                 ; 131: "" (nhradn graf. znak)
         db        dvud,' '                 ; 132: """ dvojuvozovky dole
         db        nofn,'_'                 ; 133: "_"
         db        kriz,' '                 ; 134: "" k
         db        kriz,'_'                 ; 135: "" dvojk
         db        nofn,197                 ; 136: "" (nhradn graf. znak)
         db        prom,' '                 ; 137: "%" promile
         db        hacv,'S'                 ; 138: "S" s hkem
         db        nofn,'<'                 ; 139: "<"
         db        carv,'S'                 ; 140: "S" s rkou
         db        hacv,'T'                 ; 141: "T" s hkem
         db        hacv,'Z'                 ; 142: "Z" s hkem
         db        carv,'Z'                 ; 143: "Z" s rkou
         db        nofn,192                 ; 144: "" (nhradn grafick znak)
         db        carm," "                 ; 145: "'" rka
         db        hacp," "                 ; 146: "'" hek vpravo
         db        dvur,' '                 ; 147: """ dvojuvozovky nahoe vpravo
         db        dvul,' '                 ; 148: """ dvojuzovovky nahoe vlevo
         db        nofn,7                   ; 149: " " (takov njak ublk)
         db        nofn,'-'                 ; 150: "-"
         db        nofn,196                 ; 151: "" (nhradn graf. znak "")
         db        nofn,179                 ; 152: " " (nhradn graf. znak "")
         db        kolo,'t'                 ; 153: " "  TM
         db        hacm,'s'                 ; 154: "s" s hkem
         db        nofn,'>'                 ; 155: ">"
         db        carm,'s'                 ; 156: "s" s rkou
         db        hacp,'t'                 ; 157: "t" s hkem
         db        hacm,'z'                 ; 158: "z" s hkem
         db        carm,'z'                 ; 159: "z" s rkou
         db        nofn,250                 ; 160: " " pevn mezera
         db        hacv,' '                 ; 161: " " hek
         db        misv,' '                 ; 162: miska nad velkm psmenem
         db        skrl,'L'                 ; 163: "L" pekrtnut
         db        spc1,' '                 ; 164: rubl
         db        pats,'A'                 ; 165: "A" s patikou
         db        nofn,'|'                 ; 166: "|"
         db        nofn,21                  ; 167: paragraf
         db        dvot,' '                 ; 168: dvojteka nad znakem
         db        kolo,'c'                 ; 169: "c" copyright
         db        ocap,'S'                 ; 170: "S" s ocskem
         db        nofn,27                  ; 171: "" (namsto toho je ipka)
         db        nofn,191                 ; 172: "" (m to bt jako psmenko)
         db        nofn,''                 ; 173: "-"
         db        kolo,'r'                 ; 174: "R" registr.
         db        tecv,'Z'                 ; 175: "Z" s tekou
         db        krom,' '                 ; 176: "" krouek
         db        nofn,241                 ; 177: " " + -
         db        pats,' '                 ; 178: patika
         db        skrs,'l'                 ; 179: "l" pekrtnut
         db        carm,' '                 ; 180: rka vpravo
         db        nofn,230                 ; 181: "" (m bt velk)
         db        nofn,227                 ; 182: "" (m bt velk)
         db        nofn,7                   ; 183: "."
         db        ocap,' '                 ; 184: ocsek
         db        pats,'a'                 ; 185: "a" s patikou
         db        ocap,'s'                 ; 186: "s" s ocskem
         db        nofn,26                  ; 187: "" (namsto toho je ipka)
         db        hacp,'L'                 ; 188: "L" s hkem
         db        dvom,' '                 ; 189: dvojrka
         db        hacp,'l'                 ; 190: "l" s hkem
         db        tecm,'z'                 ; 191: "z" s tekou
         db        carv,'R'                 ; 192: "R" s rkou
         db        carv,'A'                 ; 193: "A" s rkou
         db        strv,'A'                 ; 194: "A" se stkou
         db        misv,'A'                 ; 195: "A" s miskou
         db        dvot,'A'                 ; 196: "A" s dvojtekou
         db        carv,'L'                 ; 197: "L" s rkou
         db        carv,'C'                 ; 198: "C" s rkou
         db        ocap,'C'                 ; 199: "C" s ocskem
         db        hacv,'C'                 ; 200: "C" s hkem
         db        carv,'E'                 ; 201: "E" s rkou
         db        pats,'E'                 ; 202: "E" s patikou
         db        dvot,'E'                 ; 203: "E" s dvojtekou
         db        hacv,'E'                 ; 204: "E" s hkem
         db        carv,'I'                 ; 205: "I" s rkou
         db        strv,'I'                 ; 206: "I" se stkou
         db        hacv,'D'                 ; 207: "D" s hkem
         db        skrl,'D'                 ; 208: "D" pekrtnut
         db        carv,'N'                 ; 209: "N" s rkou
         db        hacv,'N'                 ; 210: "N" s hkem
         db        carv,'O'                 ; 211: "O" s rkou
         db        strv,'O'                 ; 212: "O" se stkou
         db        dvov,'O'                 ; 213: "O" s dvojrkou
         db        dvot,'O'                 ; 214: "O" s dvojtekou
         db        nofn,'x'                 ; 215: pekrtnut
         db        hacv,'R'                 ; 216: "R" s hkem
         db        krov,'U'                 ; 217: "U" s kroukem
         db        carv,'U'                 ; 218: "U" s rkou
         db        dvov,'U'                 ; 219: "U" s dvojrkou
         db        dvot,'U'                 ; 220: "U" s dvojtekou
         db        carv,'Y'                 ; 221: "Y" s rkou
         db        ocap,'T'                 ; 222: "T" s ocskem
         db        nofn,''                 ; 223: "" - beta
         db        carm,'r'                 ; 224: "r" s rkou
         db        carm,'a'                 ; 225: "a" s rkou
         db        strv,'a'                 ; 226: "a" se stkou
         db        mism,'a'                 ; 227: "a" s miskou
         db        dvot,'a'                 ; 228: "a" s dvojtekou
         db        carv,'l'                 ; 229: "l" s rkou
         db        carm,'c'                 ; 230: "c" s rkou
         db        ocap,'c'                 ; 231: "c" s ocskem
         db        hacm,'c'                 ; 232: "c" s hkem
         db        carm,'e'                 ; 233: "e" s rkou
         db        pats,'e'                 ; 234: "e" s patikou
         db        dvot,'e'                 ; 235: "e" s dvojtekou
         db        hacm,'e'                 ; 236: "e" s hkem
         db        carm,'i'                 ; 237: ""
         db        strv,'i'                 ; 238: "i" se stkou
         db        hacp,'d'                 ; 239: "d" s hkem
         db        skrp,'d'                 ; 240: "d" pekrtnut
         db        carm,'n'                 ; 241: "n" s rkou
         db        hacm,'n'                 ; 242: "n" s hkem
         db        carm,'o'                 ; 243: "o" s rkou
         db        strv,'o'                 ; 244: "o" se stkou
         db        dvom,'o'                 ; 245: "o" s dvojrkou
         db        dvot,'o'                 ; 246: "o" s dvojtekou
         db        nofn,':'                 ; 247: ""
         db        hacm,'r'                 ; 248: "r" s hkem
         db        krom,'u'                 ; 249: "u" s kroukem
         db        carm,'u'                 ; 250: "u" s rkou
         db        dvom,'u'                 ; 251: "u" s dvojrkou
         db        dvot,'u'                 ; 252: "u" s dvojtekou
         db        carm,'y'                 ; 253: "y" s rkou
         db        ocap,'t'                 ; 254: "t" s ocskem
         db        tecv,' '                 ; 255: teka nad velkm psmenem
         dw        0
TabWIN0  label     byte

Command  db        128 dup(0)               ; buffer pkazovho dku

Code     ENDS
         END       Start
